--- The real update & more mineshafts --- 3/19/2022
♦ Improved a lot the placement of mineshafts, byebye ugly air spaces.
♦ Added 5 more types of mineshafts: spruce, birch, jungle, acacia and dark oak, they spawn in there respective biome.
♦ Make mineshafts larger, is gonna help a lot if you wanna find caves.
--- Advancements & tweaking generation --- 3/26/2022
♦ Now it has 2 new advancements.
♦ Mineshafts are just a little bit more common now, and also tweak the generation.
--- Compatibility & Rewarding --- 4/30/2022
♦ TheBrackenPack compatibility, a cool dimension datapack.
♦ Added 5 more rooms and also they spawn more frequently.
♦ Added mineshaft mobs, go prepare.
♦ Added traps, occasionally they are gonna generate in some paths, be careful on your steps. 
♦ Lots of Bug fixes and tweaks. (locate command, generation, spamming logs, lag)
--- Fabric/Forge Mod version --- 5/15/2022
♦ Fixed a unused loottable on a room
♦ And yes! Mod version have been release, someone was asking for it, here is! 
--- 1.19 Update --- 6/11/2022
♦ Literally improve everything
♦ Add new paths with lots of variations
♦ Minecarts can now spawn
♦ Nerfed zombies that spawn on rooms 
♦ Increase the spawn of the rooms (again lol)
♦ Mangrove mineshaft is real!
♦ Improve the desing of some pillars
♦ Mineshaft can now spawn on deepslate levels
♦ Fix bug when mineshaft spawn near rivers or oceans
♦ Fix untencional bad generation
♦ Fix some trap that usually explode everything lol
--- The "Minecart" Update --- 7/15/2022
♦ Fix "Hanging entity at invalid position" line, spamming on logs
♦ Added new paths
♦ Added minecart exploration! these include new loots, some lore, and teach you some sculk mechanics
♦ Added Compatibility with "William Wythers' Overhauled" Worldgen
♦ Improve performance of generation
--- Quality of Changes and Performance --- 2/11/2023
♦ Generation is twice faster (i promise)
♦ Added 13 new rooms (farms, music, potions, stews, copper and more) each one with his own unique loot
♦ Powered rails are now activated, makes explore mineshafts more faster and fun.
♦ Added new fun structures like an ascensor, and some hidden rooms, and make generation of this ones more consistent
♦ Mobs now spawn in more strategic places
♦ Mineshafts are more easily to find
♦ Improve the generation of rooms, making exploring more rewarding
♦ Now you can see some pieces of the mineshaft coming to the surface
♦ Biomesoplenty compatibility
--- 1.19.4 Update --- 3/31/2023
♦ Not too much this time, welcome to 1.19.4
♦ Tweaked once again, generation of mineshaft, the Y level and frequencies
--- 3 more mineshafts and 1.20 Update --- 
♦ 1.20 support
♦ Added bamboo mineshaft
♦ Added cherry mineshaft
♦ Added mud mineshaft
♦ Added 'Who built this' advancement (when you find one random mineshaft)
♦ Added 'Mineshafter' (when you find all the 12 types of mineshafts) good luck on this one, you will be rewarded with lots of xp :D 
♦ Some mineshaft mobs now use armor trims in them (will add more variations in the future)
♦ Updated some mineshaft pieces in the pool, this is still in development but I decided to give you guys a sneak peak;)
♦ Mineshafts now will spawn deeper, at deepslate levels
♦ Mineshafts will generate a little weird (again) this change is really minimal but it will gain more performance on servers
--- 1.20.2 Support ---
♦ Yeah! that's it, nothing new for now until university finish
--- A total rewrite --- 1/29/24
♦ Completely changed the way of how the pieces of the structure generates, basically my pieces used to crash each other and generate too close.
♦ Added many more mineshafts pieces, so with this update my goal is to don't get bored of always seeing the same mineshaft piece over and over again
♦ Added pots with loot and chests around it, this pots can have: "Emeralds, TNT, bundle, pickaxes, Experience Bottles, and Lanters"
♦ Vindicators spawn rarely in mineshafts, careful!
♦ Added to a new poisonous skeleton, this was inspired by the new incoming minecraft structure "Trial Chambers" this new skeleton has more health than usual.
♦ Updated every single structure, adding more wood details.
♦ Rooms generation has been reduced, it some scenarios was too overpowered.
♦ Totally changed how mineshafts variations generate. Adding more chance to make the others generate.
♦ Added some RARE ores being generated around the mineshafts, you can find those while you walk around it, here are some data that you might like to know.
- Stone mineshaft generate lapis and iron
- Deepslate mineshaft generate gold and redstone
- Oak mineshaft generate emerald and iron
- Spruce mineshaft generate copper and emerald
- Birch mineshaft generate iron and lapis
- Acacia mineshaft generate iron and copper
- Dark Oak mineshaft generate gold and coal
- Jungle mineshaft generate lapis and emerald
- Mangrove mineshaft generate redstone and coal
- Bamboo mineshaft generate lapis and emerald
- Cherry mineshaft generate iron and lapis
- Mud mineshaft generate redstone and coal
♦ All mineshaft now tends to generate more deeper, hopefully this fix mineshafts spawing around the surface, which sometimes looked really bad tbh.
♦ Deleted some old mineshaft pieces, some of them just really look bad.
♦ Fixed a bug that makes my custom banners and potions don't have their custom name.
♦ Added a dungeon cave spider structure.
♦ General improvements.
--- The Cobweb and Edges Update, kind of --- 3/7/24
♦ Added a experimental change, increase the generation of cobwebs in many structures pieces around the mineshafts, this changes was made to make mineshafts kinda more harder to explore and make the structure look better!
♦ Improved the /locate structure 
♦ Changes on some loot tables (diamond room, books room, arrows room)
♦ Added some more mobs 
♦ Changed some pieces of mineshafts, slighly and added some more pots around the place, i just love pots guys!
♦ Fixed a bug that makes some pieces look ugly showing weird huge squares, now they look more smooth.
♦ Tweaked gen once again, i'm preparing stuff for the future 1.21...
--- The details and better loot update --- 4/10/24
♦ Neoforge support, YAY!!!
♦ Added a license
♦ Oh boy, there is a lot to see in this update, even tho, seems that nothing changes, exploring this new mineshafts, are gonna be so much fun now
♦ Added archeology gameplay
♦ When you find a mineshaft now will give you some xp
♦ First, some tweaks again in mineshaft generation (this give me big plans for adding mineshaft entrances, but for now, it  will be in a future update)
♦ Changed some mineshaft pieces floor, now there is a stone floor, this was made to trying to avoid unintentional lava spots to get infire all the mineshaft (and not only that, to be fair, it looks much better in this way, and less ugly to eyes)
♦ Talking about the other change, that stone floor it's not just "stone", i decided to add details there, like moss cobblestone, gravel and "suspicious gravel" Yes!!! i'm giving use to brush, one of the forgotten tools of minecraft 
♦ Added more details in general, rails now will have something to see, you have barrels, skeletons head, mushroom, and more!!!
♦ Improved A LOT the loottables, to be honest, my old loot tables are kinda boring, now they have more stuff to see, giving more reasons to explore my mineshafts
♦ Speaking about loots, i improved the exiting ones and also added "brand unique items" to some of the "suspicious gravel", if i type here all the different stuff that you will find here, this changelog note will never end...
♦ Added more of 20 unique pretty banners (banners like cats, creatures, weapons, references, sculk, sky, and more!), armor trims, sherds, and some interesting items.
♦ Remove experimental change adding cowbes in the floor of the mineshaft
♦ Added two brand new mobs, The Old Miner which is a zombified villager with a pickaxe and The Old Explorer...
♦ Buffed mineshafts ores generation, ocasionally you will find some ores blocks around the mineshafts, and more. Example : "Deepslate Mineshaft generate more diamonds", "Stone Mineshaft generate more lapis and iron" and etc. Discover it for yourself :)
♦ Credits to all the creators of banners, you can find them on the PMC banners page
--- 1.21 Pre-release Support ---
♦ Rewrite the whole code of my proyect to make it compatible with the latest version such as 1.20.5-1.20.6
♦ Some changes of some loot tables, and that's it 
--- Tricky Trials Moment ---
♦ 1.21 Support 
♦ Renamed folder names, for the latest 1.21 update 
♦ Increased slightly the generation of mineshaft, finding mineshafts should be easier now (feedback change, thank you! if you wanna send feedback, you can always do so by joining my discord server)
♦ Added 2 more mineshaft types, lush and dripstone types. As the name says, these will be generated in his respective biomes. It can be pretty small, but kinda common to find.
♦ Replaced my old poison skeleton, for the "Bogged"
♦ Mineshafts now generate rarely with the Bogged with some slight buffs (won't spawn again)
♦ Improved mineshaft speed generation, once again, changing the "size" value in my .JSON file 
♦ Smooth out deepslate mineshaft, reducing some blocks generation,  adding tuff bricks 
♦ Fixed mineshaft being waterlogged, thanks Mojang
♦ "Mineshafter" advancement requires the two new mineshafts.
--- The Fix Crash Update ---
♦ Fixed a imporant crash when generating new chunks, a super rare bad event, saturating the server, not happening anymore.
♦ To fix the other issue, mineshafts have been a little bit smaller, you probably won't notice this tho
♦ Fixed some splash potions not being name correctly
♦ Remove vanilla mesa mineshaft generating at normal mountains.
--- Ocean Mineshaft Fix --- 7/24/24
♦ Sometimes mineshaft generate off in all the oceans, making it look ugly as hell, so i just removed the ocean biomes in the list, this was a important fix. Sorry to all of ya
--- Enchants changes & One new desing --- 7/28/24
♦ So 1.21 bring lots of changes to enchantments, and since some of my loot tables randomize enchants, this also counts the treasure enchantments ones, like the swift sneak, soul speed, etc, being too OP and breaking the survival experience, thanks Joji and the many other members for reporting this on my discord.
♦ And an extra gift, added a new path desing, using chains, looks cool.
--- 1.21.3 drop! --- 10/24/24
♦ 1.21.1, 1.21.2, 1.21.3 updated
♦ Nerfed the cave spider poison, being too op to kill players.
♦ Did some slight changes on worldgen generation again.
♦ Some mineshafts like the acacia one sometimes generated outside caves.
--- 1.21.4 drop! --- 12/15/24
♦ Added a little creepy sound when you enter to one of my mineshafts for the first time ever, i like add small details like this, the sound is not that creepy tho! :)
♦ Added the Pale Mineshaft, as always they are almost the same as the other ones, however this structure it's another alternative to get Creaking Hearts
♦ 1.21.4 compat
--- ☺ The Pilars and Paths --- 2/1/25
♦ One of the updates that change the gameplay a lot, here we go, I probably forgot some other things to add in this little message, there is a lot new.
♦ Added more paths variations, 9 new different mineshafts desing, each of them with something special to offer, you can learn redstone, a trial spawner, and some nice desings.
♦ Added a credits.txt file, yep, some of my redstone builds are not made by me, in fact, i watch a tutorial and adapt it to my proyect, you can find youtube links that lead to the original build creator, they deserver credits.
♦ Make more mineshafts more hard to find
♦ Improved a lot mineshaft generation
♦ This bug that makes mineshafts generate in terrain, should be FIXED NOW! After many updates trying to fix it, it should be this one, for real...
♦ Cherry mineshaft generating bamboo blocks, it's fixed
♦ Best SICK thing, if mineshafts detect air above it, pillars will generate, kinda like how vanilla mineshafts do too! About time... this took weeks, it needed a total rewrite of the structures.
♦ Someone suggested on discord, and this is it, it's Downgrade time! Added alternative downloads to my old versions, 1.21 and 1.20, please enjoy! :D if you have any feedback, be free to dm me.
♦ And more! Some balance with how details generate, furnaces generating correctly, anvils being more rare and more, mineshafts should be more fun, more paths variations makes them less boring.
--- 1.21.5 Compat and Maps --- 30/3/25
♦ 1.21.5 compatibility 
♦ New maps and rooms have been added
♦ Each mineshaft will have a biome room, this one it's unique and changes depending on what mineshaft you are in. Example: Oak mineshaft could have a chance to generate a lush cave biome room, that will let you to that place, there are plenty of maps, and this also will make it easier to find all the mineshaft variants and get the Mineshafter advancement.
♦ Added 2 new villagers' rooms, adding more gameplay, with their banners and loot.
♦ Speaking about advancements the 'Who Built this?' Has been renamed to "So we back in the mine..." it's better the reference.
♦ Fixed a bug when old banners looked with a different inconsistent color and bad format.
♦ Tweaks of how rooms generate
♦ Nerfed some raw ore blocks generated in the mineshaft randomly, it was nice but to OP 
♦ Cherry, bamboo, and mud mineshafts have decreased the size, even tho they could look nice, after doing some tests, I don't feel it too 'vanilla friendly' the others are good tho.
♦ Added better compatibility with terralith caves
--- Chase the Skies Drop --- 23/06/25
♦ Rarely logs will spam a warn message telling that some loot tables have not been loaded correctly, now this has been fixed
♦ Thanks to mojang, in this new drop, rails finally generate correctly, thank god
♦ 1.21.6 compatibility
--- COOPER AGE TIME! --- 13/10/2025
♦ Updated to 1.21.9 - 1.21.10
♦ Certain mobs have been updated to have copper gear now, the chainmail armor didn't fit the vibe, copper looks great.
♦ Copper room has been changed, adding a copper golem statue.
--- Hotfix - Room with a command block --- 20/10/2025
♦ The title say it all, i forgot to remove a command block in a room, accidents happens...
--- Mounts of mayhem! --- 3/1/2026
♦ Added spears in loots.
♦ Added some copper gear in loots.
♦ Make mineshaft just a little bit more easier to find, feedback note.
♦ 1.21.11 compatibility.
--- Tiny Takeover! --- 28/3/2026
♦ Updated to 26.1
--- Chaos Cubed! --- 6/17/2026
♦ Updated to 26.2
